--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY configurable_u1 IS
  PORT(
      DA : IN std_logic_vector(7 downto 0);
      DB : IN std_logic_vector(7 downto 0);
      DC : IN std_logic_vector(7 downto 0);
      DD : IN std_logic_vector(7 downto 0);
      DE : IN std_logic_vector(7 downto 0);
      DF : IN std_logic_vector(7 downto 0);
      DG : IN std_logic_vector(7 downto 0);
      DH : IN std_logic_vector(7 downto 0);
      DI : IN std_logic_vector(7 downto 0);
      DJ : IN std_logic_vector(7 downto 0);
      DK : IN std_logic_vector(7 downto 0);
      DL : IN std_logic_vector(7 downto 0);
      DM : IN std_logic_vector(7 downto 0);
      DN : IN std_logic_vector(7 downto 0);
      DO : IN std_logic_vector(7 downto 0);
      DP : IN std_logic_vector(7 downto 0);
      Y : OUT std_logic_vector(7 downto 0);
      S : IN std_logic_vector(3 downto 0)
  );
END configurable_u1;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF configurable_u1 IS
BEGIN
    PROCESS(DA, DB, DC, DD, DE, DF, DG, DH, DI, DJ, DK, DL, DM, DN, DO, DP, S)
    BEGIN
        CASE S IS
            WHEN "0000" =>
                Y <= DA;
            WHEN "0001" =>
                Y <= DB;
            WHEN "0010" =>
                Y <= DC;
            WHEN "0011" =>
                Y <= DD;
            WHEN "0100" =>
                Y <= DE;
            WHEN "0101" =>
                Y <= DF;
            WHEN "0110" =>
                Y <= DG;
            WHEN "0111" =>
                Y <= DH;
            WHEN "1000" =>
                Y <= DI;
            WHEN "1001" =>
                Y <= DJ;
            WHEN "1010" =>
                Y <= DK;
            WHEN "1011" =>
                Y <= DL;
            WHEN "1100" =>
                Y <= DM;
            WHEN "1101" =>
                Y <= DN;
            WHEN "1110" =>
                Y <= DO;
            WHEN "1111" =>
                Y <= DP;
            WHEN OTHERS => NULL;
        END CASE;
    END PROCESS;
END structure;
--------------------------------------------------------------------------------
